diff -Nur linux.old/drivers/net/3c509.c linux.new/drivers/net/3c509.c
--- linux.old/drivers/net/3c509.c	Sat May 11 13:53:45 2002
+++ linux.new/drivers/net/3c509.c	Sat May 11 13:55:09 2002
@@ -567,7 +567,7 @@
 /* Read a word from the EEPROM using the regular EEPROM access register.
    Assume that we are in register window zero.
  */
-static ushort __init read_eeprom(int ioaddr, int index)
+static ushort read_eeprom(int ioaddr, int index)
 {
 	outw(EEPROM_READ + index, ioaddr + 10);
 	/* Pause for at least 162 us. for the read to take place. */