diff -urN old/drivers/sound/sb_common.c new/drivers/sound/sb_common.c
--- old/drivers/sound/sb_common.c	Sat Jun 23 14:27:29 2001
+++ new/drivers/sound/sb_common.c	Sat Jun 23 14:27:19 2001
@@ -753,6 +753,7 @@
 		case 3:		/* SB Pro and most clones */
 			switch (devc->model) {
 			case 0:
+				if (devc->minor == 2) goto ALS120_HACK;
 				devc->model = hw_config->card_subtype = MDL_SBPRO;
 				if (hw_config->name == NULL)
 					hw_config->name = "Sound Blaster Pro (8 BIT ONLY)";
@@ -764,6 +765,7 @@
 			break;
 
 		case 4:
+		ALS120_HACK:
 			devc->model = hw_config->card_subtype = MDL_SB16;
 			/* 
 			 * ALS007 and ALS100 return DSP version 4.2 and have 2 post-reset !=0