diff -Nur linux-2.4.9/kernel/sched.c linux-2.4.9-kd/kernel/sched.c
--- linux-2.4.9/kernel/sched.c	Sat Aug 25 10:48:10 2001
+++ linux-2.4.9-kd/kernel/sched.c	Sat Aug 25 10:50:04 2001
@@ -175,7 +175,7 @@
 		/* .. and a slight advantage to the current MM */
 		if (p->mm == this_mm || !p->mm)
 			weight += 1;
-		weight += 20 - p->nice;
+		weight += (20 - p->nice)*1000;
 		goto out;
 	}
 
@@ -184,7 +184,7 @@
 	 * runqueue (taking priorities within processes
 	 * into account).
 	 */
-	weight = 1000 + p->rt_priority;
+	weight = 1000000 + p->rt_priority;
 out:
 	return weight;
 }
@@ -578,7 +578,7 @@
 	 * Default process to select..
 	 */
 	next = idle_task(this_cpu);
-	c = -1000;
+	c = -1000000;
 	if (prev->state == TASK_RUNNING)
 		goto still_running;
 